



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>HEAP[xxx.exe]:Invalid Address specified to RtlValidateHeap 错误的解决方法总结</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">HEAP[xxx.exe]:Invalid Address specified to RtlValidateHeap 错误的解决方法总结</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 06:06:15 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><img referrerpolicy="no-referrer"src="http://img.my.csdn.net/uploads/201211/30/1354273667_6585.jpg" /></p>
<h3>一、情况</h3>
<p>抽象出问题是这样的：</p>
<p>class&nbsp;DLL_API1&nbsp;A</p>
<p>{</p>
<p>func()</p>
<p>{</p>
<p>vector&nbsp;vec;</p>
<p>B&nbsp;b;</p>
<p>b.func(vec);</p>
<p>return&nbsp;TRUE;</p>
<p>}</p>
<p>}</p>
<p>其中B是另一个导出类，定义如下</p>
<p>{</p>
<p>private:</p>
<p>vector&nbsp;m_vec;</p>
<p>public:</p>
<p>func(&nbsp;vector&nbsp;&amp;vec&nbsp;)</p>
<p>{</p>
<p>vec&nbsp;=&nbsp;m_vec;</p>
<p>}</p>
<p>}</p>
<p>运行时发现，每次运行到A的return TRUE释放vector的时候，都会报错：user breakpoint called from code at&nbsp; xxxxxxxxxxxxx，并在Debug的提示框中出现：</p>
<p>HEAP[xxx.exe]:Invalid Address specified to RtlValidateHeap&nbsp;&nbsp;&nbsp; 的提示。</p>
<p>网上查了下，基本上都是说是dll和exe在不同的地方开辟了空间，在不同的地方释放的问题。看来以后还需要注意呢。</p>
<p><strong>解决的方法是：</strong></p>
<p>是外层被使用的内存，可以在外层定义后传参到非托管函数，在内部赋值后，在外层被调用，然后被释放；在内部被申请的空间，需在内部显式的的释放，避免造成内存泄露，这样就不会出现上述两种错误。（引用自：<a href="http://155134558.blog.163.com/blog/static/22278462009727103058451/" rel="external nofollow noreferrer">http://155134558.blog.163.com/blog/static/22278462009727103058451/</a>）</p>
<p>也就是说可以做如下修改：</p>
<div>
<ol><li>class&nbsp;DLL_API1&nbsp;A</li>
<li>{</li>
<li>func()</li>
<li>{</li>
<li>B&nbsp;b;</li>
<li>int&nbsp;nCnt&nbsp;=&nbsp;b.func1();</li>
<li>vector&nbsp;vec;</li>
<li>b.func2(vec);</li>
<li>return&nbsp;TRUE;</li>
<li>}</li>
<li>}</li>
<li>class&nbsp;DLL_API2&nbsp;B</li>
<li>{</li>
<li>private:</li>
<li>vector&nbsp;m_vec;</li>
<li>public:</li>
<li>int&nbsp;func1()</li>
<li>{</li>
<li>return&nbsp;m_vec.size();</li>
<li>}</li>
<li>func2(&nbsp;vector&nbsp;&amp;vec&nbsp;)</li>
<li>{</li>
<li>vec&nbsp;=&nbsp;m_vec;</li>
<li>}</li>
<li>}</li></ol>
</div>
<p>不过目前这种解决方案看起来是比较挫啦，不知道能不能从设计上避免。这个问题就先放在这里吧。以后有更多经验的时候再回头看。</p>
<h3>二、情况</h3>
<p>遇到该问题的原因是，托管代码和非托管代码之间的分配机制不同，两者之间可以进行互操作，下面是查到的相关内容：</p>
<p>经过一段时间对MSDN的钻研，终于明白C++/CLI互操作共分三种：</p>
<p>1.P/Invoke</p>
<p>2.Com interop</p>
<p>3.C++ interop</p>
<p>我想版主推荐的是指采用C++ interop方式。代码过程如下：</p>
<p>1.将非托管结构和函数放在#pragmaunmanaged内，像这样</p>
<p>#pragma&nbsp;unmanaged</p>
<p>struct&nbsp;cUserNestedStruct</p>
<p>{</p>
<p>.........</p>
<p>}&nbsp;;</p>
<p>extern&nbsp;"C"&nbsp;int&nbsp;DllFunction(UserDefinedStruct**);</p>
<p>2. 然后，在托管代码中就可以直接调用了。</p>
<p>managed</p>
<p>int&nbsp;main()</p>
<p>{</p>
<p>UserDefinedStruct*&nbsp;&nbsp;&nbsp;mystruct&nbsp;=&nbsp;new&nbsp;UserDefinedStruct();</p>
<p>int&nbsp;num&nbsp;=&nbsp;DLLFunction(&amp;mystruct);</p>
<p>}</p>
<p>上述是调用Dll，进行互操作的情况。</p>
<p>在我们的项目中，使用托管和非托管混合的方法，通过头文件，直接调用非托管程序。这里需要注意的是：托管代码的内存管理和非托管的内存管理是不同的。在内存堆的分配上也是不同的，所以，两者之间不能直接进行内存的互调用，例如：1，在非托管代码中不能释放托管代码申请的内存；</p>
<p>2，在非托管代码中申请的内存，在函数结束后就被释放，如果被return到托管环境里，是无效的地址。</p>
<p>是外层被使用的内存，可以在外层定义后传参到非托管函数，在内部赋值后，在外层被调用，然后被释放；在内部被申请的空间，需在内部显式的的释放，避免造成内存泄露，这样就不会出现上述两种错误。</p>
<p>本项目中的问题是在非托管代码中，使用了对托管代码中内存块的一个引用，然后在函数结束时，被释放，这样就是free掉了托管代码中申请的内存，会报错，访问无效的内存。</p>
<h3>三、情况</h3>
<p>在编译的时候，exe和dll有可能链接的是静态的运行时库，也有可能链接的是dll版本的运行时库。如果在exe或者是dll中有一个链接的是静态的运行时库，那么就会存在两套内存分配的实例。所以在dll中申请的内存，到exe中释放就会失败，因为exe并不认识那块内存。解决的办法就是都使用dll版本的运行时库，这样，在进程空间内，只有一个运行时实例。</p>
<h3>四、情况</h3>
<p>WCHAR&nbsp;aPathname[]=L"\\\\c:\\pbk_temp";</p>
<p>WCHAR&nbsp;aFilename[]=L"100.dat";</p>
<p>DWORD&nbsp;dwLimitedReadSize=0;</p>
<p>unsigned&nbsp;char*&nbsp;content;</p>
<p>content=NULL;</p>
<p>.......</p>
<p>dwResult&nbsp;=&nbsp;CONAReadFile(hFS,&nbsp;&amp;FileInfo,&nbsp;content,&nbsp;dwLimitedReadSize,&nbsp;aPathname);</p>
<p>.........</p>
<p>delete&nbsp;[]&nbsp;content;</p>
<p>content=NULL;</p>
<p>CONAReadFile是Nokia提供的一个函数，原型为<br />DWORD&nbsp;CONAReadFile(FSHANDLE&nbsp;hFSHandle,&nbsp;LPCONAPI_FILE_INFO&nbsp;pFileInfo,&nbsp;unsigned&nbsp;char**&nbsp;ppFileData,&nbsp;DWORD&nbsp;dwLimitedReadSize,&nbsp;const&nbsp;WCHAR*&nbsp;pstrTargetPath)</p>
<p>现在我只要一执行delete&nbsp;[]&nbsp;content;程序就崩了。单步跟出现提示信息HEAP[PROPERTYSHEET.exe]:&nbsp;Invalid&nbsp;Address&nbsp;specified&nbsp;to&nbsp;RtlValidateHeap(&nbsp;00A90000,&nbsp;00197CC8&nbsp;)</p>
<p>这是怎么回事？该怎么解决。如果不delete会不会造成内存泄漏。</p>
<p>原因：</p>
<p>在Nokia的库中同时提供了释放char*&nbsp;content的方法，因为char*&nbsp;content指向的内存是由dll中的方法分配的，所以应该由dll中的方法释放。这正好符合C++关于谁分配，谁释放的准侧。<br />从这个例子，我们可以看到，以后在写dll时，如果在dll中的某个方法内部分配了内存，同时要写一个释放该段内存的方法，对外公开，用来给外部的函数调用</p>
<h3>五、情况</h3>
<p>我封装了dll&nbsp;原来是exe&nbsp;现在封装成dll<br />发现了这个错误&nbsp;函数都执行没问题&nbsp;就是函数执行完&nbsp;就爆这个错误<br />我没用dll什么的&nbsp;就用了string</p>
<p>调用是</p>
<p>void&nbsp;CTestDlg::OnButton1()</p>
<p>{</p>
<p>//&nbsp;TODO:&nbsp;Add&nbsp;your&nbsp;control&nbsp;notification&nbsp;handler&nbsp;code&nbsp;here</p>
<p>UpdateData(TRUE);</p>
<p>string&nbsp;ts&nbsp;=&nbsp;m_text;</p>
<p>string&nbsp;sData&nbsp;=&nbsp;_ConvertHextoCString(ts);</p>
<p>AfxMessageBox(sData.c_str());</p>
<p>}</p>
<p>dll封装函数是</p>
<p>#include&nbsp;"stdafx.h"</p>
<p>#include&nbsp;&lt;string&gt;</p>
<p>using&nbsp;namespace&nbsp;std;</p>
<p>BOOL&nbsp;APIENTRY&nbsp;DllMain(&nbsp;HANDLE&nbsp;hModule,&nbsp;&nbsp;&nbsp;DWORD&nbsp;&nbsp;ul_reason_for_call,&nbsp;LPVOID&nbsp;lpReserved)</p>
<p>{</p>
<p>return&nbsp;TRUE;</p>
<p>}</p>
<p>string&nbsp;ConvertHextoString(string&nbsp;hex)</p>
<p>{</p>
<p>string&nbsp;result;</p>
<p>char&nbsp;temp[3];</p>
<p>int&nbsp;i&nbsp;=&nbsp;0;</p>
<p>int&nbsp;nLen&nbsp;=&nbsp;hex.length();</p>
<p>if&nbsp;(nLen%2&nbsp;!=&nbsp;0)</p>
<p>{</p>
<p>return&nbsp;"ERROR";</p>
<p>}</p>
<p>return&nbsp;result;</p>
<p>}</p>
<p>问题解决了&nbsp;封装dll&nbsp;最好类型不要用string&nbsp;这样很容易有问题<br />还有就是在传入参数&nbsp;加上const这样&nbsp;就保证不会有问题了</p>
<h3>六、情况</h3>
<p>Dll之间由于由于空间分配和删除引起的</p>
<p>invalid address specified to rtlvalidateheap</p>
<p>在外层模块中定义了一个变量，传入内层模块赋值，用完后在外层模块释放时出错。</p>
<p><strong>一个可能的原因：</strong></p>
<p>在不同模块（工程）之间传递 C++ 类，<strong>而这两个模块用了不同的运行时库（Runtime Library）设置</strong>。</p>
<p>例如：EXE 模块调用 DLL 模块里传递 C++ 类的函数，但 DLL 模块使用静态链接（Release 是 Multi-threaded (/MT)、Debug 是 Multi-threaded Debug (/MTd)）方式编译，而 EXE 模块使用动态链接（Release 是 Multi-threaded DLL (/MD)、Debug 是 Multi-threaded Debug DLL (/MDd)）方式编译。</p>
<p>可以对比这两个模块的工程属性 - C/C++ - Code Generation - Runtime Library，看看设置是否一样，如果不一样要改成一样的。</p>
<p>如果无法解决问题，那就是别的原因了。</p>
<h3>七、情况</h3>
<p>析构函数出问题</p>
<p>调试信息：</p>
<p>HEAP[MHPSO.exe]: Invalid Address specified to RtlValidateHeap( 00390000, 00DAAC68 )<br />Windows 已在 MHPSO.exe 中触发一个断点。</p>
<p>其原因可能是堆被损坏，这说明&nbsp;MHPSO.exe 中或它所加载的任何 DLL 中有 Bug。</p>
<p><strong>一般是野指针导致。<br /></strong></p>
<p>八、</p>
<p>转载自：&nbsp;<a href="http://www.bhcode.net/article/20100713/12048.html" rel="external nofollow noreferrer">http://www.bhcode.net/article/20100713/12048.html</a></p>
<p>//微粒类</p>
<p>class&nbsp;PARTICLE</p>
<p>{</p>
<p>public:</p>
<p>double&nbsp;*X;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//微粒的坐标数组</p>
<p>double&nbsp;*V;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//微粒的速度数组</p>
<p>double&nbsp;*XBest;&nbsp;&nbsp;//微粒的最好位置数组</p>
<p>int&nbsp;Dim;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//微粒的维数</p>
<p>double&nbsp;Fit;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//微粒适合度</p>
<p>double&nbsp;FitBest;&nbsp;//微粒最好位置适合度</p>
<p>//构造函数</p>
<p>PARTICLE();&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//空构造函数</p>
<p>PARTICLE(int&nbsp;n);//维数为参数的构造函数</p>
<p>//析构函数</p>
<p>~PARTICLE();</p>
<p>void&nbsp;SetDim(int&nbsp;d);&nbsp;//设置微粒的维数</p>
<p>};</p>
<p>//微粒构造函数</p>
<p>PARTICLE::PARTICLE()&nbsp;//空构造函数</p>
<p>{</p>
<p>X&nbsp;=&nbsp;0;&nbsp;V&nbsp;=&nbsp;0;&nbsp;XBest&nbsp;=&nbsp;0;&nbsp;Dim&nbsp;=&nbsp;0;</p>
<p>}</p>
<p>PARTICLE::PARTICLE(int&nbsp;n)&nbsp;//维数为参数的构造函数</p>
<p>{</p>
<p>if(n&lt;0)</p>
<p>{</p>
<p>cout&lt;&lt;"输入有错，维数必须大于0"&lt;&lt;endl;</p>
<p>return;</p>
<p>}</p>
<p>Dim&nbsp;=&nbsp;n;</p>
<p>X&nbsp;=&nbsp;new&nbsp;double[Dim];</p>
<p>V&nbsp;=&nbsp;new&nbsp;double[Dim];</p>
<p>XBest&nbsp;=&nbsp;new&nbsp;double[Dim];</p>
<p>}</p>
<p>//微粒析构函数</p>
<p>PARTICLE::~PARTICLE()</p>
<p>{</p>
<p>if(Dim)</p>
<p>{</p>
<p>delete&nbsp;X;</p>
<p>delete&nbsp;V;</p>
<p>delete&nbsp;XBest;</p>
<p>X=0;</p>
<p>V=0;</p>
<p>XBest=0;</p>
<p>}</p>
<p>}</p>
<p>//定义群粒子类</p>
<p>class&nbsp;PSO</p>
<p>{</p>
<p>public:</p>
<p>PARTICLE&nbsp;*&nbsp;Particle;&nbsp;&nbsp;&nbsp;&nbsp;//微粒群数组</p>
<p>int&nbsp;PNum;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//微粒个数</p>
<p>int&nbsp;GBestIndex;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//最好微粒索引</p>
<p>double&nbsp;W;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//惯性权重</p>
<p>double&nbsp;C1;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//加速度系数1</p>
<p>double&nbsp;C2;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//加速度系数2</p>
<p>double&nbsp;*Xup;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//微粒坐标上界数组</p>
<p>double&nbsp;*Xdown;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//微粒坐标下界数组</p>
<p>double&nbsp;*Vmax;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//微粒最大速度数组</p>
<p>void&nbsp;Initialize();&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//初始化群体</p>
<p>void&nbsp;CalFit();&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//计算全体适合度</p>
<p>virtual&nbsp;void&nbsp;ParticleFly();&nbsp;//微粒飞翔，产生新一代微粒</p>
<p>//通讯函数，返回值为false时，系统停止优化</p>
<p>bool&nbsp;(*Com)(double,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//最优微粒适合度</p>
<p>double*,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//最优微粒坐标数组</p>
<p>double**,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//所有微粒坐标指针数组</p>
<p>int);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//当前最优微粒索引</p>
<p>//构造函数</p>
<p>PSO();&nbsp;//空构造函数</p>
<p>PSO(int&nbsp;dim,&nbsp;//微粒维数</p>
<p>int&nbsp;num);&nbsp;//微粒个数</p>
<p>//析构函数</p>
<p>~PSO();</p>
<p>};</p>
<p>//PSO构造函数</p>
<p>PSO::PSO()</p>
<p>{</p>
<p>Particle&nbsp;=&nbsp;0;</p>
<p>PNum&nbsp;=&nbsp;0;</p>
<p>GBestIndex&nbsp;=&nbsp;0;</p>
<p>Xup&nbsp;=&nbsp;0;</p>
<p>Xdown&nbsp;=&nbsp;0;</p>
<p>W&nbsp;=&nbsp;1;</p>
<p>C1&nbsp;=&nbsp;2;</p>
<p>C2&nbsp;=&nbsp;2;</p>
<p>Com&nbsp;=&nbsp;0;</p>
<p>}</p>
<p>PSO::PSO(int&nbsp;dim,&nbsp;int&nbsp;num)</p>
<p>{</p>
<p>if(dim&lt;0&nbsp;||&nbsp;num&nbsp;&lt;0)</p>
<p>{</p>
<p>cout&lt;&lt;"输入有错，维数和粒子个数必须大于0"&lt;&lt;endl;</p>
<p>return;</p>
<p>}</p>
<p>Particle&nbsp;=&nbsp;new&nbsp;PARTICLE[num];</p>
<p>for(int&nbsp;i=0;&nbsp;i&lt;&nbsp;num;&nbsp;i++)</p>
<p>Particle[i].SetDim(dim);</p>
<p>PNum&nbsp;=&nbsp;num;</p>
<p>GBestIndex&nbsp;=&nbsp;0;</p>
<p>Xup&nbsp;=&nbsp;new&nbsp;double[dim];</p>
<p>Xdown&nbsp;=&nbsp;new&nbsp;double[dim];</p>
<p>Vmax&nbsp;=&nbsp;new&nbsp;double[dim];</p>
<p>W&nbsp;=&nbsp;1;</p>
<p>C1&nbsp;=&nbsp;2;</p>
<p>C2&nbsp;=&nbsp;2;</p>
<p>Com&nbsp;=&nbsp;0;</p>
<p>}</p>
<p>//析构函数</p>
<p>PSO::~PSO()</p>
<p>{</p>
<p>if(Particle)</p>
<p>delete&nbsp;[]Particle;</p>
<p>if(Xup)</p>
<p>delete&nbsp;[]Xup;//位置上界</p>
<p>if(Xdown)</p>
<p>delete&nbsp;[]Xdown;//位置下界</p>
<p>if(Vmax)</p>
<p>delete&nbsp;[]Vmax;&nbsp;//速度上下界</p>
<p>Xup&nbsp;=&nbsp;0;</p>
<p>Xdown&nbsp;=&nbsp;0;</p>
<p>Vmax&nbsp;=&nbsp;0;</p>
<p>Particle=0;</p>
<p>}</p>
<p>//派生多种群分层的PSO类</p>
<p>class&nbsp;MHPSO</p>
<p>{</p>
<p>public:</p>
<p>PSO**&nbsp;FirstPso;&nbsp;//第一层多种群粒子群的指针的指针</p>
<p>int&nbsp;L;&nbsp;//第一层种群的个数&nbsp;=&nbsp;第二层粒子群中粒子的个数</p>
<p>double&nbsp;C3;&nbsp;//加速度系数3</p>
<p>PSO*&nbsp;SecondPso;//第二层的粒子群指针</p>
<p>HANDLE&nbsp;wMutex;</p>
<p>double&nbsp;Vmin[20]&nbsp;;&nbsp;//当粒子飞行速度小于Vmin的时，速度变化已不能更新粒子的位置，重新初始化速度</p>
<p>public:</p>
<p>MHPSO()</p>
<p>{</p>
<p>FirstPso=0;&nbsp;L=0;&nbsp;SecondPso=0;&nbsp;C3&nbsp;=&nbsp;2;</p>
<p>for(int&nbsp;i=0;i&lt;20;i++)</p>
<p>Vmin[i]&nbsp;=&nbsp;0.0001&nbsp;;</p>
<p>wMutex&nbsp;=&nbsp;::CreateMutex(NULL,false,NULL);</p>
<p>}</p>
<p>//构造函数，给出微粒维数n&nbsp;和种群个数L,种群中粒子的个数m</p>
<p>MHPSO(int&nbsp;n,&nbsp;int&nbsp;m,int&nbsp;L)</p>
<p>{</p>
<p>this-&gt;L&nbsp;=&nbsp;L;</p>
<p>FirstPso&nbsp;=&nbsp;new&nbsp;PSO*[L];</p>
<p>for(int&nbsp;i=0&nbsp;;i&lt;&nbsp;L;i++)</p>
<p>FirstPso[i]&nbsp;=&nbsp;new&nbsp;PSO(n,m);</p>
<p>SecondPso&nbsp;=&nbsp;new&nbsp;PSO(n,L);</p>
<p>C3&nbsp;=&nbsp;2;</p>
<p>for(int&nbsp;i=0;i&lt;20;i++)</p>
<p>Vmin[i]&nbsp;=&nbsp;0.0001&nbsp;;</p>
<p>wMutex&nbsp;=&nbsp;::CreateMutex(NULL,false,NULL);</p>
<p>}</p>
<p>~MHPSO()</p>
<p>{</p>
<p>for(int&nbsp;i=0;i&lt;L;i++)</p>
<p>{</p>
<p>delete&nbsp;this-&gt;FirstPso[i];</p>
<p>this-&gt;FirstPso[i]&nbsp;=0;</p>
<p>}</p>
<p>delete&nbsp;[]FirstPso;</p>
<p>this-&gt;FirstPso&nbsp;=&nbsp;0;</p>
<p>delete&nbsp;SecondPso;</p>
<p>SecondPso&nbsp;=0;&nbsp;//这两句有问题。。。，如果去掉程序就不会出错。。</p>
<p>::CloseHandle(wMutex);</p>
<p>}</p>
<p>};</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnjyvx8.html">存储过程 Row&lowbar;number&lpar;&rpar; 分页</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4mdr5q.html">ios-深度解析二维码的生成与使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn5wwjq.html">内存分配与Segmentation fault</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r1vwm8.html">优先级反转实验，使用信号量实现【RT-Thread学习笔记 5】</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zlv2vq.html">ORACLE SQL调优案例一则</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwp0438.html">WPF Navigation</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j37m0q.html">ORA-00119&colon; invalid specification for system parameter LOCAL&lowbar;LISTENER - 转</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0nxn4q.html">第三百二十五天 how can I 坚持</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mgppjq.html">malloc、free的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnkg1oq.html">1043&period; Is It a Binary Search Tree &lpar;25&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90von0j8.html">自己写一个strcmp函数（C&plus;&plus;）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kloo09.html">Java 8&mdash;&mdash;Optional</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj3kkeq.html">Linux学习笔记-林耐斯Notes-Linux就该这么学</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gez4pz8.html">学习js函数--函数定义</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpryxr9.html">c&num;游戏进程杀手</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdd6709.html">Oracle报错&num;&OpenCurlyDoubleQuote;ORA-01791&colon; 不是 SELECTed 表达式&rdquo;解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvv6lx8.html">Java并发编程之AQS</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rn5j49.html">深入解析内存原理：RAM的基本原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2mz3y9.html">E&period; Bear and Drawing</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn6z4eq.html">webstorm皮肤外观样式快速设置，CMD的使用方法，webstorm11激活方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlm4rg69.html">DUIEngine使用Visual Studio 2010编译Debug&lowbar;Dll版有关Error MSB3073错误解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnvv3e8.html">iOS开发中文件的上传和下载功能的基本实现-备用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mrkxeq.html">ubuntu 下GIT的安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k17xz69.html">MySQL 优化方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okemm19.html">hdu 1301 Jungle Roads</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn01grq.html">WINDOWS&plus;NGINX&plus;DJANGO&plus;FLUP&plus;PYTHON起步~</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvl4xyq.html">这样就算会了PHP么？-4</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd21kk8.html">Codeforces 276D Little Girl and Maximum XOR</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w470wq.html">安卓，通过本地应用分享到微信、facebook等</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydke6gq.html">cf413E Maze 2D</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
